;
; #########################################################################

;     Assembler specific instructions for 32 bit ASM code

      .386                   ; minimum processor needed for 32 bit
      .model flat, stdcall   ; FLAT memory model & STDCALL calling
      option casemap :none   ; set code to case sensitive

; #########################################################################

     include windows.inc
     include user32.inc
     include kernel32.inc
     include comdlg32.inc
     include Comctl32.inc
     include rasapi32.inc
      
     includelib user32.lib
     includelib kernel32.lib
     includelib comdlg32.lib
     includelib Comctl32.lib
     includelib rasapi32.lib

; #########################################################################

    WinMain PROTO

    RASENTRYNAME5A STRUCT
        dwSize dd ?
        szEntryName db 260 dup(?)
        dwFlags dd ?
        szPhonebookPath db 264 dup(?)
    RASENTRYNAME5A ENDS

    RASENTRYNAME5 EQU <RASENTRYNAME5A>

    RASDIALPARAMS4A STRUCT
        dwSize dd ?
        szEntryName db 101h dup(?)
        szPhoneNumber db 81h dup(?)
        szCallbackNumber db 81h dup(?)
        szUserName db 101h dup(?)
        szPassword db 101h dup(?)
        szDomain db 13h dup(?)

        dwSubEntry dd ?
        dwCallbackId dd ?
    RASDIALPARAMS4A ENDS

    RASDIALPARAMS4 EQU <RASDIALPARAMS4A>

    .data
    szApp db "HiHiHI",0
    szSucc db "Fiese sache!",0
    .code

start:

    invoke WinMain

    invoke ExitProcess,eax

WinMain proc

      LOCAL lpRasEntryName    :DWORD
 LOCAL dwCb   :DWORD
 LOCAL dwEntries  :DWORD
 LOCAL rp   :RASDIALPARAMS4
 LOCAL fPass   :BOOL
 LOCAL hConn   :DWORD

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 mov dwCb, sizeof RASENTRYNAME5
      mov lpRasEntryName, 0

AllocateRasEntryNameLoop:

      cmp lpRasEntryName, 0
      je AllocateRasEntryName
      invoke GetProcessHeap
      invoke HeapFree, eax, 0, lpRasEntryName

AllocateRasEntryName:
      invoke GetProcessHeap
      invoke HeapAlloc, eax, 0, dwCb
      cmp eax, 0
      je RetFail
     
      mov lpRasEntryName, eax
      invoke RtlZeroMemory, lpRasEntryName, dwCb
      mov ebx, sizeof RASENTRYNAME5
      mov eax, lpRasEntryName
      mov (RASENTRYNAME5 PTR [eax]).dwSize, ebx

      invoke RasEnumEntries, NULL, NULL, lpRasEntryName, ADDR dwCb, ADDR dwEntries
      ;cmp eax, 278h
      ;je AllocateRasEntryNameLoop
invoke RasEnumEntries, NULL, NULL, lpRasEntryName, ADDR dwCb, ADDR dwEntries
.if eax == ERROR_BUFFER_TOO_SMALL
      jmp AllocateRasEntryNameLoop
.elseif eax == ERROR_NOT_ENOUGH_MEMORY
      jmp RetFail
.elseif eax != 0
jmp RetFail
.endif
     ; cmp eax, 0
     ; jne RetFail

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
 mov dwCb, sizeof RASDIALPARAMS4
      invoke RtlZeroMemory, ADDR rp, dwCb     
      mov eax, dwCb
      mov rp.dwSize, eax

      mov eax, lpRasEntryName
 invoke lstrcpy, ADDR rp.szEntryName, ADDR (RASENTRYNAME5 PTR [eax]).szEntryName

 invoke RasGetEntryDialParams, NULL, ADDR rp, ADDR fPass
      cmp eax, 0
      jne RetFail


      mov hConn, 0
 invoke RasDial, NULL, NULL, ADDR rp, 0, NULL, ADDR hConn
      cmp eax, 0
      jne RetFail
      invoke MessageBox,0,addr szSucc,addr szApp,MB_OK
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
RetFail:

      cmp lpRasEntryName, 0
      je AllocateRasEntryName
      invoke GetProcessHeap
      invoke HeapFree, eax, 0, lpRasEntryName

      ret

WinMain endp

end start